import bpy
from .lib import *
from .ui import *
from .inits import *
from .typing import *
def get_node_by_type(nodes,node_type):
        return next(iter(node for node in nodes if node.type == node_type), None)
def get_node_by_name(nodes,node_name):
        return next(iter(node for node in nodes if node.name == node_name), None)
def get_selected_curve_data(self, obs):
    return [{"ob": ob, "bevel_depth": ob.data.bevel_depth,
        "bevel_resolution": ob.data.bevel_resolution,
        "resolution_u": ob.data.resolution_u,
        "bevel_mode": ob.data.bevel_mode,
        "bevel_object": ob.data.bevel_object,
        "use_fill_caps": ob.data.use_fill_caps} for ob in obs if ob.type == 'CURVE']
class CBL_OT_ConvertCurveToGN(bpy.types.Operator):
    """"""
    bl_idname = "cbl.convert_curve_to_gn"
    bl_label = "Cablerator: Convert a Curve to a Geometry Node Object"
    bl_options = {"REGISTER", "UNDO"}
    @classmethod
    def poll(cls, context):
        return bpy.app.version >= (3, 1, 0) and context.selected_objects
    def get_cbl_node_group(self):
        group_name = "cablerator_geometry_curve"
        if group_name in bpy.data.node_groups:
            group =  bpy.data.node_groups[group_name]
            nodes = group.nodes
            links = group.links
            group_input = get_node_by_type(nodes,'GROUP_INPUT')
            node_circle = get_node_by_type(nodes,'CURVE_PRIMITIVE_CIRCLE')
            node_object = get_node_by_type(nodes,'OBJECT_INFO')
            node_curve_to_mesh = get_node_by_type(nodes,'CURVE_TO_MESH')
            node_reroute = get_node_by_type(nodes,'REROUTE')
        else:
            group = bpy.data.node_groups.new(group_name, 'GeometryNodeTree')
            if not GV.is41:
                ser_node = r'''{"46f4ef24a73f48b6b090561860f8f084": {"name": "Curve Circle", "location": [0.0, 0.0], "type": "GeometryNodeCurvePrimitiveCircle", "inputs": [[0, 32], [1, [-1.0, 0.0, 0.0]], [2, [0.0, 1.0, 0.0]], [3, [1.0, 0.0, 0.0]], [4, 1.0]], "outputs": [[0, null, [[14, "81230cd479b54f739f5eb1f2dcb82ae6"]]], [1, [0.0, 0.0, 0.0]]], "props": [{"height": 100.0}, {"hide": false}, {"mode": "RADIUS"}, {"width": 140.0}, {"width_hidden": 100.0}]}, "5afb9c5a697f4ef5a75390acd10de46a": {"name": "Group Output", "location": [860.0, 260.0], "type": "NodeGroupOutput", "inputs": [], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"is_active_output": true}, {"width": 140.0}, {"width_hidden": 80.0}]}, "6cb6cf01a8194cf38122d90ff81e13f6": {"name": "Curve to Mesh", "location": [640.0, 200.0], "type": "GeometryNodeCurveToMesh", "inputs": [[0, null, [[0, "d93b152b30454d52b1833c4e52860ace"]]], [1, null, [[0, "f404eacaf7b94f9e9f0ec7ff3794e9e6"]]], [2, false]], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 100.0}]}, "f404eacaf7b94f9e9f0ec7ff3794e9e6": {"name": "Transform", "location": [400.0, 80.0], "type": "GeometryNodeTransform", "inputs": [[0, null, [[6, "81230cd479b54f739f5eb1f2dcb82ae6"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, [1.0, 1.0, 1.0], [[3, "15230c8f937748459b54ccf4e4307ddc"]]]], "outputs": [[0, null, [[1, "6cb6cf01a8194cf38122d90ff81e13f6"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 100.0}]}, "393e51f8505f41379fc41617957e1ab2": {"name": "Object Info", "location": [0.0, -140.0], "type": "GeometryNodeObjectInfo", "inputs": [[0, null], [1, false]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0], [[9, "15230c8f937748459b54ccf4e4307ddc"]]], [3, null, [[15, "81230cd479b54f739f5eb1f2dcb82ae6"]]]], "props": [{"height": 100.0}, {"hide": false}, {"transform_space": "ORIGINAL"}, {"width": 140.0}, {"width_hidden": 100.0}]}, "1c80bb5bba384eef94ca8d580fba5bec": {"name": "Reroute", "location": [140.0, 100.0], "type": "NodeReroute", "inputs": [[0, false]], "outputs": [[0, false, [[1, "81230cd479b54f739f5eb1f2dcb82ae6"], [0, "15230c8f937748459b54ccf4e4307ddc"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 100.0}]}, "d93b152b30454d52b1833c4e52860ace": {"name": "Group Input", "location": [-240.0, 240.0], "type": "NodeGroupInput", "inputs": [], "outputs": [[0, null, [[0, "6cb6cf01a8194cf38122d90ff81e13f6"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 80.0}]}, "81230cd479b54f739f5eb1f2dcb82ae6": {"name": "Switch", "location": [200.0, 60.0], "type": "GeometryNodeSwitch", "inputs": [[0, false], [1, false, [[0, "1c80bb5bba384eef94ca8d580fba5bec"]]], [2, 0.0], [3, 0.0], [4, 0], [5, 0], [6, false], [7, true], [8, [0.0, 0.0, 0.0]], [9, [0.0, 0.0, 0.0]], [10, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [11, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [12, ""], [13, ""], [14, null, [[0, "46f4ef24a73f48b6b090561860f8f084"]]], [15, null, [[3, "393e51f8505f41379fc41617957e1ab2"]]], [16, null], [17, null], [18, null], [19, null], [20, null], [21, null], [22, null], [23, null], [24, null], [25, null]], "outputs": [[0, 0.0], [1, 0], [2, false], [3, [0.0, 0.0, 0.0]], [4, [0.0, 0.0, 0.0, 0.0]], [5, ""], [6, null, [[0, "f404eacaf7b94f9e9f0ec7ff3794e9e6"]]], [7, null], [8, null], [9, null], [10, null], [11, null]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "GEOMETRY"}, {"width": 140.0}, {"width_hidden": 100.0}]}, "15230c8f937748459b54ccf4e4307ddc": {"name": "Switch.001", "location": [195.5906219482422, -120.74932861328125], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "1c80bb5bba384eef94ca8d580fba5bec"]]], [1, false], [2, 0.0], [3, 0.0], [4, 0], [5, 0], [6, false], [7, true], [8, [1.0, 1.0, 1.0]], [9, [0.0, 0.0, 0.0], [[2, "393e51f8505f41379fc41617957e1ab2"]]], [10, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [11, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [12, ""], [13, ""], [16, null], [17, null], [18, null], [19, null], [20, null], [21, null], [22, null], [23, null], [24, null], [25, null]], "outputs": [[0, 0.0], [1, 0], [2, false], [3, [0.0, 0.0, 0.0], [[3, "f404eacaf7b94f9e9f0ec7ff3794e9e6"]]], [4, [0.0, 0.0, 0.0, 0.0]], [5, ""], [7, null], [8, null], [9, null], [10, null], [11, null]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "VECTOR"}, {"width": 140.0}, {"width_hidden": 100.0}]}}'''
            else:
                ser_node = r'''{"15c5d6736fbb43339d77a9af54a1d9d2": {"name": "Curve Circle", "location": [0.0, 0.0], "type": "GeometryNodeCurvePrimitiveCircle", "inputs": [[0, 32], [1, [-1.0, 0.0, 0.0]], [2, [0.0, 1.0, 0.0]], [3, [1.0, 0.0, 0.0]], [4, 1.0]], "outputs": [[0, null, [[1, "0aa40bdbb1164155a28d1005598c0d4a"]]], [1, [0.0, 0.0, 0.0]]], "props": [{"height": 100.0}, {"hide": false}, {"mode": "RADIUS"}, {"width": 140.0}]}, "ccefd499501a4a3ebc07db1519308bc1": {"name": "Group Output", "location": [920.0, 260.0], "type": "NodeGroupOutput", "inputs": [], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"is_active_output": true}, {"width": 140.0}]}, "0177463e6f23490387189f49f851b83c": {"name": "Curve to Mesh", "location": [700.0, 200.0], "type": "GeometryNodeCurveToMesh", "inputs": [[1, null, [[0, "282bc064f306404fb1ccc2f16dff5a8d"]]], [2, false]], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "282bc064f306404fb1ccc2f16dff5a8d": {"name": "Transform", "location": [460.0, 80.0], "type": "GeometryNodeTransform", "inputs": [[0, null, [[0, "0aa40bdbb1164155a28d1005598c0d4a"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, [1.0, 1.0, 1.0], [[0, "7045097fb86949b8ba30e31e76b6e733"]]]], "outputs": [[0, null, [[1, "0177463e6f23490387189f49f851b83c"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "8f6857c3337443a892ec92ca3e3cfc0e": {"name": "Object Info", "location": [-80.0, -160.0], "type": "GeometryNodeObjectInfo", "inputs": [[0, null], [1, false]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0], [[0, "5b0917ecfea445748cd48c5701c7a116"]]], [3, null, [[2, "0aa40bdbb1164155a28d1005598c0d4a"]]]], "props": [{"height": 100.0}, {"hide": false}, {"transform_space": "ORIGINAL"}, {"width": 140.0}]}, "af7e6fd3a8824b7a87e5bb24f514d14b": {"name": "Group Input", "location": [-180.0, 240.0], "type": "NodeGroupInput", "inputs": [], "outputs": [[1, 0.0], [2, 0], [3, null], [4, false], [5, false]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "0aa40bdbb1164155a28d1005598c0d4a": {"name": "Switch", "location": [280.0, 100.0], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "1b8d84c9358847dc8c2b2fb45e346e28"]]], [1, null, [[0, "15c5d6736fbb43339d77a9af54a1d9d2"]]], [2, null, [[3, "8f6857c3337443a892ec92ca3e3cfc0e"]]]], "outputs": [[0, null, [[0, "282bc064f306404fb1ccc2f16dff5a8d"]]]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "GEOMETRY"}, {"width": 140.0}]}, "7045097fb86949b8ba30e31e76b6e733": {"name": "Switch.001", "location": [300.0, -120.0], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "1b8d84c9358847dc8c2b2fb45e346e28"]]], [1, [1.0, 1.0, 1.0]], [2, [0.0, 0.0, 0.0], [[0, "5b0917ecfea445748cd48c5701c7a116"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "282bc064f306404fb1ccc2f16dff5a8d"]]]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "VECTOR"}, {"width": 140.0}]}, "5b0917ecfea445748cd48c5701c7a116": {"name": "Vector Math", "location": [120.0, -340.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[2, "8f6857c3337443a892ec92ca3e3cfc0e"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[2, "7045097fb86949b8ba30e31e76b6e733"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ABSOLUTE"}, {"width": 140.0}]}, "1b8d84c9358847dc8c2b2fb45e346e28": {"name": "Reroute", "location": [160.0, 100.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "0aa40bdbb1164155a28d1005598c0d4a"], [0, "7045097fb86949b8ba30e31e76b6e733"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}}'''
            bpy.temp_string_serializer = [[0, 0], group, ser_node]
            bpy.ops.cbl.deserialize_node('INVOKE_DEFAULT')
            nodes = group.nodes
            links = group.links
            group_input = get_node_by_type(nodes,'GROUP_INPUT')
            group_output = get_node_by_type(nodes,'GROUP_OUTPUT')
            node_circle = get_node_by_type(nodes,'CURVE_PRIMITIVE_CIRCLE')
            node_object = get_node_by_type(nodes,'OBJECT_INFO')
            node_curve_to_mesh = get_node_by_type(nodes,'CURVE_TO_MESH')
            node_reroute = get_node_by_type(nodes,'REROUTE')
            if GV.after4:
                group.interface.new_socket("Geometry", in_out="INPUT", socket_type="NodeSocketGeometry")
                group.interface.new_socket("Circle Radius", in_out="INPUT", socket_type="NodeSocketFloat")
                group.interface.new_socket("Circle Resolution", in_out="INPUT", socket_type="NodeSocketInt")
                group.interface.new_socket("Bevel Object", in_out="INPUT", socket_type="NodeSocketObject")
                group.interface.new_socket("Use Object as a Profile", in_out="INPUT", socket_type="NodeSocketBool")
                group.interface.new_socket("Fill Caps", in_out="INPUT", socket_type="NodeSocketBool")
                group.interface.new_socket("Geometry", in_out="OUTPUT", socket_type="NodeSocketGeometry")
            else:
                group.inputs.new('NodeSocketGeometry','Geometry')
                group.inputs.new('NodeSocketFloat','Circle Radius')
                group.inputs.new('NodeSocketInt','Circle Resolution')
                group.inputs.new('NodeSocketObject','Bevel Object')
                group.inputs.new('NodeSocketBool','Use Object as a Profile')
                group.inputs.new('NodeSocketBool','Fill Caps')
                group.outputs.new('NodeSocketGeometry','Geometry')
            links.new(group_input.outputs[0], node_curve_to_mesh.inputs[0])
            links.new(node_curve_to_mesh.outputs[0], group_output.inputs[0])
            links.new(group_input.outputs[1], node_circle.inputs[4])
            links.new(group_input.outputs[2], node_circle.inputs[0])
            links.new(group_input.outputs[3], node_object.inputs[0])
            links.new(group_input.outputs[4], node_reroute.inputs[0])
            links.new(group_input.outputs[5], node_curve_to_mesh.inputs[2])
        return [None, None, None, None, None, group]
        return [group_input, node_circle, node_object, node_curve_to_mesh, node_reroute, group]
    def execute(self, context):
        self.obs = get_selected_curve_data(self, context.selected_objects)
        if not self.obs:
            self.report({'ERROR'}, "No valid curve objects were found among the selected objects, Aborting")
            return {'CANCELLED'}
        for obj in self.obs:
            curve, bevel_depth, bevel_resolution, resolution_u, bevel_mode, bevel_object, use_fill_caps = obj.values()
            if obj["bevel_mode"] == 'OBJECT':
                curve.data.bevel_object = None
            curve.data.bevel_depth = 0
            geo_mod = curve.modifiers.new(name='Cablerator GN',type='NODES')
            group_input, node_circle, node_object, node_curve_to_mesh, node_reroute, geo_group = self.get_cbl_node_group()
            geo_mod.node_group = geo_group
            input_name = "Socket" if GV.after4 else "Input"
            if bevel_mode == 'OBJECT':
                geo_mod[f"{input_name}_4"] = True
                geo_mod[f"{input_name}_3"] = bevel_object
            elif bevel_mode == 'ROUND':
                geo_mod[f"{input_name}_4"] = False
                geo_mod[f"{input_name}_2"] = math.ceil(linear(bevel_resolution, 0, 6, 4, 16))
                geo_mod[f"{input_name}_1"] = bevel_depth
            geo_mod[f"{input_name}_5"] = use_fill_caps
            curve.update_tag()
        return {'FINISHED'}
class CBL_OT_ConvertToMultiCableGN(bpy.types.Operator):
    """"""
    bl_idname = "cbl.convert_to_multicable"
    bl_label = "Cablerator: Convert To Geo Nodes Multicable"
    bl_options = {"REGISTER", "UNDO"}
    @classmethod
    def poll(cls, context):
        return bpy.app.version >= (3, 1, 0) and context.selected_objects
    def get_cbl_node_group(self):
        group_name = "cablerator_geometry_multicurve"
        if group_name in bpy.data.node_groups:
            group =  bpy.data.node_groups[group_name]
        else:
            group = bpy.data.node_groups.new(group_name, 'GeometryNodeTree')
            if not GV.is41:
                ser_node = r'''{"1433fd0d3539451ea2804f33a9bd307a": {"name": "Set Position", "location": [301.76470947265625, 40.235294342041016], "type": "GeometryNodeSetPosition", "inputs": [[0, null, [[0, "4d5c845d69c348d4b16eba4870bf6cfb"]]], [1, true, [[0, "a1c0f9c570b8402d9ad29d526ce3a18f"]]], [2, [0.0, 0.0, 0.0]], [3, [0.0, 0.0, 0.0], [[0, "7080f57297c24b4fbfe653a0bd038aeb"]]]], "outputs": [[0, null, [[0, "6a422670ef3944c6ab47df8bfb418493"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "01a90e8c621a4cc58b9910e117158c38": {"name": "Vector Math.001", "location": [-1508.8236083984375, -181.05882263183594], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "bea41f50d4724b16afa3e4a48b3976bc"]]], [1, [0.0, 0.0, 1.0], [[0, "d97ea2f7e138418e80c02fc435891467"]]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "f48a8616ce6f43f7a11535a3ea661203"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "CROSS_PRODUCT"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "4d5c845d69c348d4b16eba4870bf6cfb": {"name": "Set Position.001", "location": [-140.8235321044922, 140.8235321044922], "type": "GeometryNodeSetPosition", "inputs": [[0, null, [[0, "199c5cb8de5d44d1b921fd2c5d0be9ca"]]], [1, true], [2, [0.0, 0.0, 0.0]], [3, [0.0, 0.0, 0.0], [[0, "f52740bad20b4051b0d41e810bcc0f31"]]]], "outputs": [[0, null, [[0, "1433fd0d3539451ea2804f33a9bd307a"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "a1c0f9c570b8402d9ad29d526ce3a18f": {"name": "Boolean Math", "location": [80.47058868408203, -40.235294342041016], "type": "FunctionNodeBooleanMath", "inputs": [[0, false, [[0, "e3993b2e3efa426bb684efe572eb85b6"]]], [1, false]], "outputs": [[0, false, [[1, "1433fd0d3539451ea2804f33a9bd307a"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "NOT"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "7080f57297c24b4fbfe653a0bd038aeb": {"name": "Random Value", "location": [80.47058868408203, -160.94117736816406], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, -0.5], [[0, "38104af897bc4d42b486898d19d9dba7"]]], [1, [0.0, 0.0, 0.5], [[0, "26d9da4d2ef5467eac8003a8e3fb27fa"]]], [2, 0.0], [3, 1.0], [4, 0], [5, 100], [6, 0.5], [7, 0], [8, 55, [[0, "c1f64f0f260740cfa82c9f0ac1562e06"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "1433fd0d3539451ea2804f33a9bd307a"]]], [1, 0.0], [2, 0], [3, false]], "props": [{"data_type": "FLOAT_VECTOR"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "38104af897bc4d42b486898d19d9dba7": {"name": "Vector Math.005", "location": [-160.94117736816406, -482.82354736328125], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "26d9da4d2ef5467eac8003a8e3fb27fa"]]], [1, [-1.0, -1.0, -1.0]], [2, [0.0, 0.0, 0.0]], [3, -1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "7080f57297c24b4fbfe653a0bd038aeb"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "15188d7cbae54c38a12c33c43c2753fc": {"name": "Math", "location": [-1388.11767578125, -342.0], "type": "ShaderNodeMath", "inputs": [[0, -1.0], [1, 0.5, [[0, "2b7983b7c11a4721be64b839db688da1"]]], [2, 0.5]], "outputs": [[0, 0.0, [[2, "695e968f259c4fe3a594bfaaabf1f3a0"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "MULTIPLY"}, {"use_clamp": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "d1df5e2eadd74cea909c60d893a15a07": {"name": "Math.002", "location": [-1388.11767578125, -502.9411926269531], "type": "ShaderNodeMath", "inputs": [[0, -1.0], [1, 0.5, [[0, "b2f3bff491cb45579e5f58efdd8308ae"]]], [2, 0.5]], "outputs": [[0, 0.0, [[2, "e6947ed6c27b426b805cc2b2bdba80d4"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "MULTIPLY"}, {"use_clamp": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "d97ea2f7e138418e80c02fc435891467": {"name": "Vector Math", "location": [-1508.8236083984375, 20.117647171020508], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "bea41f50d4724b16afa3e4a48b3976bc"]]], [1, [0.0, 0.0, 1.0]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[1, "01a90e8c621a4cc58b9910e117158c38"], [0, "1bbc1f1cecf4469693d19cfa343191ce"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "CROSS_PRODUCT"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "1bbc1f1cecf4469693d19cfa343191ce": {"name": "Vector Math.002", "location": [-1166.8236083984375, -20.117647171020508], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "d97ea2f7e138418e80c02fc435891467"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 5.960464477539063e-08, [[1, "695e968f259c4fe3a594bfaaabf1f3a0"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "f52740bad20b4051b0d41e810bcc0f31"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "199c5cb8de5d44d1b921fd2c5d0be9ca": {"name": "Duplicate Elements", "location": [-402.35296630859375, 261.5294189453125], "type": "GeometryNodeDuplicateElements", "inputs": [[0, null, [[0, "e90432b5f1b242618eb812acc3ab5f43"]]], [1, true], [2, 8, [[0, "a780e13843aa4732b442e22b05d5a939"]]]], "outputs": [[0, null, [[0, "4d5c845d69c348d4b16eba4870bf6cfb"]]], [1, 0, [[7, "695e968f259c4fe3a594bfaaabf1f3a0"], [7, "e6947ed6c27b426b805cc2b2bdba80d4"]]]], "props": [{"domain": "SPLINE"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "f52740bad20b4051b0d41e810bcc0f31": {"name": "Vector Math.004", "location": [-643.7647094726562, -120.70588684082031], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "1bbc1f1cecf4469693d19cfa343191ce"]]], [1, [0.0, 0.0, 0.0], [[0, "f48a8616ce6f43f7a11535a3ea661203"]]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "4d5c845d69c348d4b16eba4870bf6cfb"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ADD"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "e3993b2e3efa426bb684efe572eb85b6": {"name": "Endpoint Selection", "location": [-140.8235321044922, -120.70588684082031], "type": "GeometryNodeCurveEndpointSelection", "inputs": [[0, 1], [1, 1]], "outputs": [[0, false, [[0, "a1c0f9c570b8402d9ad29d526ce3a18f"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "32974232b16d4ddcab4cd12247e376f8": {"name": "Switch", "location": [684.0, -543.176513671875], "type": "GeometryNodeSwitch", "inputs": [[0, false], [1, false, [[0, "3efa3ce3dcdb4c5aae753ffe6d526cda"]]], [2, 0.0], [3, 0.0], [4, 0], [5, 0], [6, false], [7, true], [8, [0.0, 0.0, 0.0]], [9, [0.0, 0.0, 0.0]], [10, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [11, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [12, ""], [13, ""], [14, null, [[0, "c3007da71a0b466aaa43759081e097e5"]]], [15, null, [[3, "a5d1e9c3a67843199b1dbbc6462342a9"]]], [16, null], [17, null], [18, null], [19, null], [20, null], [21, null], [22, null], [23, null], [24, null], [25, null]], "outputs": [[0, 0.0], [1, 0], [2, false], [3, [0.0, 0.0, 0.0]], [4, [0.0, 0.0, 0.0, 0.0]], [5, ""], [6, null, [[0, "73f838c7c93340488e9607040abb4b0f"]]], [7, null], [8, null], [9, null], [10, null], [11, null]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "GEOMETRY"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "a5d1e9c3a67843199b1dbbc6462342a9": {"name": "Object Info", "location": [482.82354736328125, -744.3529663085938], "type": "GeometryNodeObjectInfo", "inputs": [[0, null, [[0, "07c64819a64b42f5a016f2aa1c293b6e"]]], [1, false]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0], [[9, "8fb3c603ae2f45a699ed38a0d948fe8a"]]], [3, null, [[15, "32974232b16d4ddcab4cd12247e376f8"]]]], "props": [{"height": 100.0}, {"hide": false}, {"transform_space": "ORIGINAL"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "6a422670ef3944c6ab47df8bfb418493": {"name": "Curve to Mesh", "location": [1106.4705810546875, -120.70588684082031], "type": "GeometryNodeCurveToMesh", "inputs": [[0, null, [[0, "1433fd0d3539451ea2804f33a9bd307a"]]], [1, null, [[0, "73f838c7c93340488e9607040abb4b0f"]]], [2, false, [[0, "e70097891de24bd486b160c801f4847e"]]]], "outputs": [[0, null, [[0, "f6caded33b6c452baa9a5cdeaed9f432"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "f6caded33b6c452baa9a5cdeaed9f432": {"name": "Join Geometry", "location": [1287.5294189453125, 100.58824157714844], "type": "GeometryNodeJoinGeometry", "inputs": [[0, null, [[0, "e90432b5f1b242618eb812acc3ab5f43"], [0, "6a422670ef3944c6ab47df8bfb418493"]]]], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "8fb3c603ae2f45a699ed38a0d948fe8a": {"name": "Switch.001", "location": [684.0, -724.2352905273438], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "3efa3ce3dcdb4c5aae753ffe6d526cda"]]], [1, false], [2, 0.0], [3, 0.0], [4, 0], [5, 0], [6, false], [7, true], [8, [1.0, 1.0, 1.0]], [9, [0.0, 0.0, 0.0], [[2, "a5d1e9c3a67843199b1dbbc6462342a9"]]], [10, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [11, [0.800000011920929, 0.800000011920929, 0.800000011920929, 1.0]], [12, ""], [13, ""], [16, null], [17, null], [18, null], [19, null], [20, null], [21, null], [22, null], [23, null], [24, null], [25, null]], "outputs": [[0, 0.0], [1, 0], [2, false], [3, [0.0, 0.0, 0.0], [[3, "73f838c7c93340488e9607040abb4b0f"]]], [4, [0.0, 0.0, 0.0, 0.0]], [5, ""], [7, null], [8, null], [9, null], [10, null], [11, null]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "VECTOR"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "73f838c7c93340488e9607040abb4b0f": {"name": "Transform Geometry", "location": [885.176513671875, -523.058837890625], "type": "GeometryNodeTransform", "inputs": [[0, null, [[6, "32974232b16d4ddcab4cd12247e376f8"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, [1.0, 1.0, 1.0], [[3, "8fb3c603ae2f45a699ed38a0d948fe8a"]]]], "outputs": [[0, null, [[1, "6a422670ef3944c6ab47df8bfb418493"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "f48a8616ce6f43f7a11535a3ea661203": {"name": "Vector Math.003", "location": [-1166.8236083984375, -160.94117736816406], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "01a90e8c621a4cc58b9910e117158c38"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 5.960464477539063e-08, [[1, "e6947ed6c27b426b805cc2b2bdba80d4"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[1, "f52740bad20b4051b0d41e810bcc0f31"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "bea41f50d4724b16afa3e4a48b3976bc": {"name": "Curve Tangent", "location": [-1710.0, -120.70588684082031], "type": "GeometryNodeInputTangent", "inputs": [], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "d97ea2f7e138418e80c02fc435891467"], [0, "01a90e8c621a4cc58b9910e117158c38"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "b2f3bff491cb45579e5f58efdd8308ae": {"name": "Reroute.001", "location": [-1468.5882568359375, -563.2941284179688], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "b6cb05c89c5c4a379d480b7dec8e5a45"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "d1df5e2eadd74cea909c60d893a15a07"], [3, "e6947ed6c27b426b805cc2b2bdba80d4"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "695e968f259c4fe3a594bfaaabf1f3a0": {"name": "Random Value.001", "location": [-1166.8236083984375, -301.76470947265625], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, 0.0]], [1, [1.0, 1.0, 1.0]], [2, 0.0, [[0, "15188d7cbae54c38a12c33c43c2753fc"]]], [3, 1.0, [[0, "2b7983b7c11a4721be64b839db688da1"]]], [4, 0], [5, 100], [6, 0.5], [7, 0, [[1, "199c5cb8de5d44d1b921fd2c5d0be9ca"]]], [8, 0, [[0, "d003586838754fc08bee12fb6fd9fdc9"]]]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, 0.0, [[3, "1bbc1f1cecf4469693d19cfa343191ce"]]], [2, 0], [3, false]], "props": [{"data_type": "FLOAT"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "e6947ed6c27b426b805cc2b2bdba80d4": {"name": "Random Value.002", "location": [-1166.8236083984375, -482.82354736328125], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, 0.0]], [1, [1.0, 1.0, 1.0]], [2, 0.0, [[0, "d1df5e2eadd74cea909c60d893a15a07"]]], [3, 1.0, [[0, "b2f3bff491cb45579e5f58efdd8308ae"]]], [4, 0], [5, 100], [6, 0.5], [7, 0, [[1, "199c5cb8de5d44d1b921fd2c5d0be9ca"]]], [8, 0, [[0, "fecba79922134386a8e0ec4b072dccd5"]]]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, 0.0, [[3, "f48a8616ce6f43f7a11535a3ea661203"]]], [2, 0], [3, false]], "props": [{"data_type": "FLOAT"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "d003586838754fc08bee12fb6fd9fdc9": {"name": "Reroute.002", "location": [-1468.5882568359375, -724.2352905273438], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "f1394b825bab4d5eb4099465336933bc"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "fecba79922134386a8e0ec4b072dccd5"], [8, "695e968f259c4fe3a594bfaaabf1f3a0"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "2b7983b7c11a4721be64b839db688da1": {"name": "Reroute", "location": [-1468.5882568359375, -402.35296630859375], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "b6cb05c89c5c4a379d480b7dec8e5a45"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "15188d7cbae54c38a12c33c43c2753fc"], [3, "695e968f259c4fe3a594bfaaabf1f3a0"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "fecba79922134386a8e0ec4b072dccd5": {"name": "Math.001", "location": [-1388.11767578125, -663.8823852539062], "type": "ShaderNodeMath", "inputs": [[0, 0.5, [[0, "d003586838754fc08bee12fb6fd9fdc9"]]], [1, 1.0], [2, 0.5]], "outputs": [[0, 0.0, [[8, "e6947ed6c27b426b805cc2b2bdba80d4"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ADD"}, {"use_clamp": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "b6cb05c89c5c4a379d480b7dec8e5a45": {"name": "Separate XYZ", "location": [-1730.11767578125, -402.35296630859375], "type": "ShaderNodeSeparateXYZ", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "5067b6c19c8e4cd89c44a92b13f3eb3a"]]]], "outputs": [[0, 0.0, [[0, "2b7983b7c11a4721be64b839db688da1"]]], [1, 0.0, [[0, "b2f3bff491cb45579e5f58efdd8308ae"]]], [2, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}, "e90432b5f1b242618eb812acc3ab5f43": {"name": "Geometry Input", "location": [-442.5882568359375, 342.0], "type": "NodeReroute", "inputs": [], "outputs": [[0, null, [[0, "199c5cb8de5d44d1b921fd2c5d0be9ca"], [0, "f6caded33b6c452baa9a5cdeaed9f432"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "a780e13843aa4732b442e22b05d5a939": {"name": "Cables No Input", "location": [-442.5882568359375, 261.5294189453125], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[2, "199c5cb8de5d44d1b921fd2c5d0be9ca"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "26d9da4d2ef5467eac8003a8e3fb27fa": {"name": "Middle Offset Input", "location": [-301.76470947265625, -462.7059020996094], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "38104af897bc4d42b486898d19d9dba7"], [1, "7080f57297c24b4fbfe653a0bd038aeb"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "c1f64f0f260740cfa82c9f0ac1562e06": {"name": "Middle Offset Seed Input", "location": [-301.76470947265625, -502.9411926269531], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[8, "7080f57297c24b4fbfe653a0bd038aeb"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "5067b6c19c8e4cd89c44a92b13f3eb3a": {"name": "Global XY Offset Input", "location": [-1830.7059326171875, -442.5882568359375], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "b6cb05c89c5c4a379d480b7dec8e5a45"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "f1394b825bab4d5eb4099465336933bc": {"name": "Global Offset Seed Input", "location": [-1830.7059326171875, -523.058837890625], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "d003586838754fc08bee12fb6fd9fdc9"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "c3007da71a0b466aaa43759081e097e5": {"name": "Curve Circle.001", "location": [502.9411926269531, -603.5294189453125], "type": "GeometryNodeCurvePrimitiveCircle", "inputs": [[0, 32, [[0, "ee4ffb2739074606986403735135673f"]]], [1, [-1.0, 0.0, 0.0]], [2, [0.0, 1.0, 0.0]], [3, [1.0, 0.0, 0.0]], [4, 1.0, [[0, "411e94b0b8a148b6a1aa22f1bb36db40"]]]], "outputs": [[0, null, [[14, "32974232b16d4ddcab4cd12247e376f8"]]], [1, [0.0, 0.0, 0.0]]], "props": [{"height": 100.0}, {"hide": false}, {"mode": "RADIUS"}, {"width": 140.0}, {"width_hidden": 0.0}]}, "411e94b0b8a148b6a1aa22f1bb36db40": {"name": "Profile Radius Input", "location": [422.4706115722656, -462.7059020996094], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[4, "c3007da71a0b466aaa43759081e097e5"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "ee4ffb2739074606986403735135673f": {"name": "Profile Res Input", "location": [422.4706115722656, -482.82354736328125], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "c3007da71a0b466aaa43759081e097e5"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "3efa3ce3dcdb4c5aae753ffe6d526cda": {"name": "Use Bevel Object Input", "location": [422.4706115722656, -502.9411926269531], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "32974232b16d4ddcab4cd12247e376f8"], [0, "8fb3c603ae2f45a699ed38a0d948fe8a"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "07c64819a64b42f5a016f2aa1c293b6e": {"name": "Profile Object Input", "location": [422.4706115722656, -523.058837890625], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "a5d1e9c3a67843199b1dbbc6462342a9"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "e70097891de24bd486b160c801f4847e": {"name": "Fill Caps Input", "location": [422.4706115722656, -543.176513671875], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[2, "6a422670ef3944c6ab47df8bfb418493"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}, {"width_hidden": 0.0}]}, "0dc1a521521e4310938b7a5084b2072d": {"name": "Group Output", "location": [1468.5882568359375, 80.47058868408203], "type": "NodeGroupOutput", "inputs": [], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"is_active_output": true}, {"width": 140.0}, {"width_hidden": 0.0}]}, "d41d569b9ab8431b8b48a60ec3d37d6c": {"name": "Group Input", "location": [-663.8823852539062, 382.23529052734375], "type": "NodeGroupInput", "inputs": [], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}, {"width_hidden": 0.0}]}}'''
            else:
                ser_node = r'''{"87a8c586f5c646aba1801096645a4d69": {"name": "Set Position", "location": [0.0, 0.0], "type": "GeometryNodeSetPosition", "inputs": [[0, null, [[0, "8b3a04257bd1469a896fb52cee6fb25a"]]], [1, true, [[0, "299a49fc07ba47719626dbf53d5514a7"]]], [2, [0.0, 0.0, 0.0]], [3, [0.0, 0.0, 0.0], [[0, "75292cb824ee4195b337e5d4604afa5f"]]]], "outputs": [[0, null, [[0, "093349173f6c4a639a8357c9b43134ea"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "6f58e28904f548949b2facba49b5163d": {"name": "Vector Math.001", "location": [-1820.0, -240.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "e841bfc7d0c7449d91fb1d036d088a9e"]]], [1, [0.0, 0.0, 1.0], [[0, "fedb73fae1d04b0483d588eecc168745"]]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "e966ce6640dc463c9203b591f90cf213"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "CROSS_PRODUCT"}, {"width": 140.0}]}, "8b3a04257bd1469a896fb52cee6fb25a": {"name": "Set Position.001", "location": [-460.0, 100.0], "type": "GeometryNodeSetPosition", "inputs": [[0, null, [[0, "29c40cc86a1a434ead5d2e8a18c24795"]]], [1, true], [2, [0.0, 0.0, 0.0]], [3, [0.0, 0.0, 0.0], [[0, "1bf0633d67964456af216ff7b248b167"]]]], "outputs": [[0, null, [[0, "87a8c586f5c646aba1801096645a4d69"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "299a49fc07ba47719626dbf53d5514a7": {"name": "Boolean Math", "location": [-220.0, -100.0], "type": "FunctionNodeBooleanMath", "inputs": [[0, false, [[0, "0291a7464da943b88a56639c0dc73016"]]], [1, false]], "outputs": [[0, false, [[1, "87a8c586f5c646aba1801096645a4d69"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "NOT"}, {"width": 140.0}]}, "75292cb824ee4195b337e5d4604afa5f": {"name": "Random Value", "location": [-220.0, -220.0], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, -0.5], [[0, "b7af9db715c6492686876aa156eb2989"]]], [1, [0.0, 0.0, 0.5], [[0, "6de97cf09c23431796c7774d54824371"]]], [2, 0.0], [3, 1.0], [4, 0], [5, 100], [6, 0.5], [7, 0], [8, 55, [[0, "da069a31e3ce445d82e223ad12fd4f69"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "87a8c586f5c646aba1801096645a4d69"]]], [1, 0.0], [2, 0], [3, false]], "props": [{"data_type": "FLOAT_VECTOR"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "b7af9db715c6492686876aa156eb2989": {"name": "Vector Math.005", "location": [-480.0, -540.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "6de97cf09c23431796c7774d54824371"]]], [1, [-1.0, -1.0, -1.0]], [2, [0.0, 0.0, 0.0]], [3, -1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "75292cb824ee4195b337e5d4604afa5f"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}]}, "3ff8f4a154534bf184edcfa849949998": {"name": "Math", "location": [-1700.0, -400.0], "type": "ShaderNodeMath", "inputs": [[0, -1.0], [1, 0.5, [[0, "2ccbeed6cf294d3ab53005a1580a86fd"]]], [2, 0.5]], "outputs": [[0, 0.0, [[2, "a56b2cdcb4884c9899d280c5fd0c8a30"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "MULTIPLY"}, {"use_clamp": false}, {"width": 140.0}]}, "5808eb40026b43bf85be1c4e59f217d2": {"name": "Math.002", "location": [-1700.0, -560.0], "type": "ShaderNodeMath", "inputs": [[0, -1.0], [1, 0.5, [[0, "9aafdd3553af419db199ec2256512213"]]], [2, 0.5]], "outputs": [[0, 0.0, [[2, "a2fed820c6d1423fa987d927076dbd87"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "MULTIPLY"}, {"use_clamp": false}, {"width": 140.0}]}, "fedb73fae1d04b0483d588eecc168745": {"name": "Vector Math", "location": [-1820.0, -20.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "e841bfc7d0c7449d91fb1d036d088a9e"]]], [1, [0.0, 0.0, 1.0]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[1, "6f58e28904f548949b2facba49b5163d"], [0, "8b6b3aeaff09483ba7ab014c71649223"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "CROSS_PRODUCT"}, {"width": 140.0}]}, "8b6b3aeaff09483ba7ab014c71649223": {"name": "Vector Math.002", "location": [-1480.0, -80.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "fedb73fae1d04b0483d588eecc168745"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 5.960464477539063e-08, [[1, "a56b2cdcb4884c9899d280c5fd0c8a30"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "1bf0633d67964456af216ff7b248b167"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}]}, "29c40cc86a1a434ead5d2e8a18c24795": {"name": "Duplicate Elements", "location": [-720.0, 220.0], "type": "GeometryNodeDuplicateElements", "inputs": [[0, null, [[0, "f31df3810aa84c1b91b7dea3072511e0"]]], [1, true], [2, 8, [[0, "823c57fabdf34b58aa23dab045496764"]]]], "outputs": [[0, null, [[0, "8b3a04257bd1469a896fb52cee6fb25a"]]], [1, 0, [[7, "a56b2cdcb4884c9899d280c5fd0c8a30"], [7, "a2fed820c6d1423fa987d927076dbd87"]]]], "props": [{"domain": "SPLINE"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "1bf0633d67964456af216ff7b248b167": {"name": "Vector Math.004", "location": [-960.0, -180.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "8b6b3aeaff09483ba7ab014c71649223"]]], [1, [0.0, 0.0, 0.0], [[0, "e966ce6640dc463c9203b591f90cf213"]]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "8b3a04257bd1469a896fb52cee6fb25a"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ADD"}, {"width": 140.0}]}, "0291a7464da943b88a56639c0dc73016": {"name": "Endpoint Selection", "location": [-460.0, -180.0], "type": "GeometryNodeCurveEndpointSelection", "inputs": [[0, 1], [1, 1]], "outputs": [[0, false, [[0, "299a49fc07ba47719626dbf53d5514a7"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "664e8691d1734600a252b27896878b94": {"name": "Switch", "location": [627.3551025390625, -593.3064575195312], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "f6305c1924184199b2c9882489b27e43"]]], [1, null, [[0, "6ef0efab0929491cad826414f06cbfe2"]]], [2, null, [[3, "bb63af60b97d44b1b8f081878779f3be"]]]], "outputs": [[0, null, [[0, "f33efed35af14e6ab955829080a99efd"]]]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "GEOMETRY"}, {"width": 140.0}]}, "bb63af60b97d44b1b8f081878779f3be": {"name": "Object Info", "location": [180.0, -800.0], "type": "GeometryNodeObjectInfo", "inputs": [[0, null, [[0, "e20d714514db4fa4907ce7ea482cee00"]]], [1, false]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0], [[0, "3357a8b1d1f14db9b7c3a4f7064e4b5c"]]], [3, null, [[2, "664e8691d1734600a252b27896878b94"]]]], "props": [{"height": 100.0}, {"hide": false}, {"transform_space": "ORIGINAL"}, {"width": 140.0}]}, "093349173f6c4a639a8357c9b43134ea": {"name": "Curve to Mesh", "location": [800.0, -180.0], "type": "GeometryNodeCurveToMesh", "inputs": [[0, null, [[0, "87a8c586f5c646aba1801096645a4d69"]]], [1, null, [[0, "f33efed35af14e6ab955829080a99efd"]]], [2, false, [[0, "54d87e7cd71943f8b914baf6c21324f1"]]]], "outputs": [[0, null, [[0, "c322b45356994b8bb644cf737803b24e"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "c322b45356994b8bb644cf737803b24e": {"name": "Join Geometry", "location": [980.0, 60.0], "type": "GeometryNodeJoinGeometry", "inputs": [[0, null, [[0, "093349173f6c4a639a8357c9b43134ea"], [0, "f31df3810aa84c1b91b7dea3072511e0"]]]], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "9c1dfac154f44dfa9e9c6074ec0a4779": {"name": "Switch.001", "location": [627.3551025390625, -773.3064575195312], "type": "GeometryNodeSwitch", "inputs": [[0, false, [[0, "f6305c1924184199b2c9882489b27e43"]]], [1, [1.0, 1.0, 1.0]], [2, [0.0, 0.0, 0.0], [[0, "3357a8b1d1f14db9b7c3a4f7064e4b5c"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[3, "f33efed35af14e6ab955829080a99efd"]]]], "props": [{"height": 100.0}, {"hide": false}, {"input_type": "VECTOR"}, {"width": 140.0}]}, "f33efed35af14e6ab955829080a99efd": {"name": "Transform Geometry", "location": [827.3551025390625, -573.3065185546875], "type": "GeometryNodeTransform", "inputs": [[0, null, [[0, "664e8691d1734600a252b27896878b94"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, [1.0, 1.0, 1.0], [[0, "9c1dfac154f44dfa9e9c6074ec0a4779"]]]], "outputs": [[0, null, [[1, "093349173f6c4a639a8357c9b43134ea"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "e966ce6640dc463c9203b591f90cf213": {"name": "Vector Math.003", "location": [-1480.0, -220.0], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "6f58e28904f548949b2facba49b5163d"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 5.960464477539063e-08, [[1, "a2fed820c6d1423fa987d927076dbd87"]]]], "outputs": [[0, [0.0, 0.0, 0.0], [[1, "1bf0633d67964456af216ff7b248b167"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "SCALE"}, {"width": 140.0}]}, "e841bfc7d0c7449d91fb1d036d088a9e": {"name": "Curve Tangent", "location": [-2020.0, -180.0], "type": "GeometryNodeInputTangent", "inputs": [], "outputs": [[0, [0.0, 0.0, 0.0], [[0, "6f58e28904f548949b2facba49b5163d"], [0, "fedb73fae1d04b0483d588eecc168745"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "9aafdd3553af419db199ec2256512213": {"name": "Reroute.001", "location": [-1780.0, -620.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "b6e6f97ff7694bc8a998ca9f3556f072"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "5808eb40026b43bf85be1c4e59f217d2"], [3, "a2fed820c6d1423fa987d927076dbd87"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "a56b2cdcb4884c9899d280c5fd0c8a30": {"name": "Random Value.001", "location": [-1480.0, -360.0], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, 0.0]], [1, [1.0, 1.0, 1.0]], [2, 0.0, [[0, "3ff8f4a154534bf184edcfa849949998"]]], [3, 1.0, [[0, "2ccbeed6cf294d3ab53005a1580a86fd"]]], [4, 0], [5, 100], [6, 0.5], [7, 0, [[1, "29c40cc86a1a434ead5d2e8a18c24795"]]], [8, 0, [[0, "219596a045cc4f578a7e1ef8a8037697"]]]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, 0.0, [[3, "8b6b3aeaff09483ba7ab014c71649223"]]], [2, 0], [3, false]], "props": [{"data_type": "FLOAT"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "a2fed820c6d1423fa987d927076dbd87": {"name": "Random Value.002", "location": [-1480.0, -540.0], "type": "FunctionNodeRandomValue", "inputs": [[0, [0.0, 0.0, 0.0]], [1, [1.0, 1.0, 1.0]], [2, 0.0, [[0, "5808eb40026b43bf85be1c4e59f217d2"]]], [3, 1.0, [[0, "9aafdd3553af419db199ec2256512213"]]], [4, 0], [5, 100], [6, 0.5], [7, 0, [[1, "29c40cc86a1a434ead5d2e8a18c24795"]]], [8, 0, [[0, "2a7510b84bab43a99ee61944061e1fb6"]]]], "outputs": [[0, [0.0, 0.0, 0.0]], [1, 0.0, [[3, "e966ce6640dc463c9203b591f90cf213"]]], [2, 0], [3, false]], "props": [{"data_type": "FLOAT"}, {"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "219596a045cc4f578a7e1ef8a8037697": {"name": "Reroute.002", "location": [-1780.0, -780.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "a019e15ab9a34918a0c942792f9dcae3"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[8, "a56b2cdcb4884c9899d280c5fd0c8a30"], [0, "2a7510b84bab43a99ee61944061e1fb6"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "2ccbeed6cf294d3ab53005a1580a86fd": {"name": "Reroute", "location": [-1780.0, -460.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "b6e6f97ff7694bc8a998ca9f3556f072"]]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "3ff8f4a154534bf184edcfa849949998"], [3, "a56b2cdcb4884c9899d280c5fd0c8a30"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "2a7510b84bab43a99ee61944061e1fb6": {"name": "Math.001", "location": [-1700.0, -720.0], "type": "ShaderNodeMath", "inputs": [[0, 0.5, [[0, "219596a045cc4f578a7e1ef8a8037697"]]], [1, 1.0], [2, 0.5]], "outputs": [[0, 0.0, [[8, "a2fed820c6d1423fa987d927076dbd87"]]]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ADD"}, {"use_clamp": false}, {"width": 140.0}]}, "b6e6f97ff7694bc8a998ca9f3556f072": {"name": "Separate XYZ", "location": [-2040.0, -460.0], "type": "ShaderNodeSeparateXYZ", "inputs": [[0, [0.0, 0.0, 0.0], [[0, "055170e98949444191f1cfa8cd300f9b"]]]], "outputs": [[0, 0.0, [[0, "2ccbeed6cf294d3ab53005a1580a86fd"]]], [1, 0.0, [[0, "9aafdd3553af419db199ec2256512213"]]], [2, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "f31df3810aa84c1b91b7dea3072511e0": {"name": "Geometry Input", "location": [-760.0, 300.0], "type": "NodeReroute", "inputs": [], "outputs": [[0, null, [[0, "29c40cc86a1a434ead5d2e8a18c24795"], [0, "c322b45356994b8bb644cf737803b24e"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "823c57fabdf34b58aa23dab045496764": {"name": "Cables No Input", "location": [-760.0, 220.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[2, "29c40cc86a1a434ead5d2e8a18c24795"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "6de97cf09c23431796c7774d54824371": {"name": "Middle Offset Input", "location": [-620.0, -520.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[1, "75292cb824ee4195b337e5d4604afa5f"], [0, "b7af9db715c6492686876aa156eb2989"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "da069a31e3ce445d82e223ad12fd4f69": {"name": "Middle Offset Seed Input", "location": [-620.0, -560.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[8, "75292cb824ee4195b337e5d4604afa5f"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "055170e98949444191f1cfa8cd300f9b": {"name": "Global XY Offset Input", "location": [-2140.0, -500.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "b6e6f97ff7694bc8a998ca9f3556f072"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "a019e15ab9a34918a0c942792f9dcae3": {"name": "Global Offset Seed Input", "location": [-2140.0, -580.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "219596a045cc4f578a7e1ef8a8037697"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "6ef0efab0929491cad826414f06cbfe2": {"name": "Curve Circle.001", "location": [200.0, -660.0], "type": "GeometryNodeCurvePrimitiveCircle", "inputs": [[0, 32, [[0, "dea169da409246309f2705da8bb2d20c"]]], [1, [-1.0, 0.0, 0.0]], [2, [0.0, 1.0, 0.0]], [3, [1.0, 0.0, 0.0]], [4, 1.0, [[0, "a8270fa89af14a4e8ad7f4f27e3b12ec"]]]], "outputs": [[0, null, [[1, "664e8691d1734600a252b27896878b94"]]], [1, [0.0, 0.0, 0.0]]], "props": [{"height": 100.0}, {"hide": false}, {"mode": "RADIUS"}, {"width": 140.0}]}, "a8270fa89af14a4e8ad7f4f27e3b12ec": {"name": "Profile Radius Input", "location": [120.0, -520.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[4, "6ef0efab0929491cad826414f06cbfe2"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "dea169da409246309f2705da8bb2d20c": {"name": "Profile Res Input", "location": [120.0, -540.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "6ef0efab0929491cad826414f06cbfe2"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "f6305c1924184199b2c9882489b27e43": {"name": "Use Bevel Object Input", "location": [120.0, -560.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "664e8691d1734600a252b27896878b94"], [0, "9c1dfac154f44dfa9e9c6074ec0a4779"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "e20d714514db4fa4907ce7ea482cee00": {"name": "Profile Object Input", "location": [120.0, -580.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[0, "bb63af60b97d44b1b8f081878779f3be"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "54d87e7cd71943f8b914baf6c21324f1": {"name": "Fill Caps Input", "location": [120.0, -600.0], "type": "NodeReroute", "inputs": [[0, [0.0, 0.0, 0.0, 0.0]]], "outputs": [[0, [0.0, 0.0, 0.0, 0.0], [[2, "093349173f6c4a639a8357c9b43134ea"]]]], "props": [{"height": 100.0}, {"hide": false}, {"width": 16.0}]}, "00cad547a8af4a1792be1beb1f134ce0": {"name": "Group Output", "location": [1271.9910888671875, 53.03829574584961], "type": "NodeGroupOutput", "inputs": [], "outputs": [], "props": [{"height": 100.0}, {"hide": false}, {"is_active_output": true}, {"width": 140.0}]}, "b80af7d7fb10465c871e0dfe9706dee3": {"name": "Group Input", "location": [-1092.3731689453125, 344.50048828125], "type": "NodeGroupInput", "inputs": [], "outputs": [[1, 0], [2, [0.0, 0.0, 0.0]], [3, 0], [4, [0.0, 0.0, 0.0]], [5, 0], [6, 0.0], [7, 0], [8, null], [9, false], [10, false]], "props": [{"height": 100.0}, {"hide": false}, {"width": 140.0}]}, "3357a8b1d1f14db9b7c3a4f7064e4b5c": {"name": "Vector Math.006", "location": [411.47698974609375, -950.4029541015625], "type": "ShaderNodeVectorMath", "inputs": [[0, [0.0, 0.0, 0.0], [[2, "bb63af60b97d44b1b8f081878779f3be"]]], [1, [0.0, 0.0, 0.0]], [2, [0.0, 0.0, 0.0]], [3, 1.0]], "outputs": [[0, [0.0, 0.0, 0.0], [[2, "9c1dfac154f44dfa9e9c6074ec0a4779"]]], [1, 0.0]], "props": [{"height": 100.0}, {"hide": false}, {"operation": "ABSOLUTE"}, {"width": 140.0}]}}'''
            bpy.temp_string_serializer = [[0, 0], group, ser_node]
            bpy.ops.cbl.deserialize_node('INVOKE_DEFAULT')
            nodes = group.nodes
            links = group.links
            group_input = get_node_by_type(nodes,'GROUP_INPUT')
            group_output = get_node_by_type(nodes,'GROUP_OUTPUT')
            reroute_Geometry_Input = get_node_by_name(nodes, "Geometry Input")
            reroute_Cables_No_Input = get_node_by_name(nodes, "Cables No Input")
            reroute_Global_XY_Offset_Input = get_node_by_name(nodes, "Global XY Offset Input")
            reroute_Global_Offset_Seed_Input = get_node_by_name(nodes, "Global Offset Seed Input")
            reroute_Middle_Offset_Input = get_node_by_name(nodes, "Middle Offset Input")
            reroute_Middle_Offset_Seed_Input = get_node_by_name(nodes, "Middle Offset Seed Input")
            reroute_Profile_Radius_Input = get_node_by_name(nodes, "Profile Radius Input")
            reroute_Profile_Res_Input = get_node_by_name(nodes, "Profile Res Input")
            reroute_Profile_Object_Input = get_node_by_name(nodes, "Profile Object Input")
            reroute_Use_Bevel_Object_Input = get_node_by_name(nodes, "Use Bevel Object Input")
            reroute_Fill_Caps_Input = get_node_by_name(nodes, "Fill Caps Input")
            node_Join_Geometry = get_node_by_name(nodes, "Join Geometry")
            if GV.after4:
                group.interface.new_socket("Geometry", in_out="INPUT", socket_type="NodeSocketGeometry")
                group.interface.new_socket("Cables No", in_out="INPUT", socket_type="NodeSocketInt")
                group.interface.new_socket("Global XY Offset", in_out="INPUT", socket_type="NodeSocketVector")
                group.interface.new_socket("Global Offset Seed", in_out="INPUT", socket_type="NodeSocketInt")
                group.interface.new_socket("Middle Offset", in_out="INPUT", socket_type="NodeSocketVector")
                group.interface.new_socket("Middle Offset Seed", in_out="INPUT", socket_type="NodeSocketInt")
                group.interface.new_socket("Circle Radius", in_out="INPUT", socket_type="NodeSocketFloat")
                group.interface.new_socket("Circle Resolution", in_out="INPUT", socket_type="NodeSocketInt")
                group.interface.new_socket("Bevel Object", in_out="INPUT", socket_type="NodeSocketObject")
                group.interface.new_socket("Use Object as a Profile", in_out="INPUT", socket_type="NodeSocketBool")
                group.interface.new_socket("Fill Caps", in_out="INPUT", socket_type="NodeSocketBool")
                group.interface.new_socket("Geometry", in_out="OUTPUT", socket_type="NodeSocketGeometry")
            else:
                group.inputs.new('NodeSocketGeometry','Geometry')
                group.inputs.new('NodeSocketInt','Cables No')
                group.inputs.new('NodeSocketVector','Global XY Offset')
                group.inputs.new('NodeSocketInt','Global Offset Seed')
                group.inputs.new('NodeSocketVector','Middle Offset')
                group.inputs.new('NodeSocketInt','Middle Offset Seed')
                group.inputs.new('NodeSocketFloat','Circle Radius')
                group.inputs.new('NodeSocketInt','Circle Resolution')
                group.inputs.new('NodeSocketObject','Bevel Object')
                group.inputs.new('NodeSocketBool','Use Object as a Profile')
                group.inputs.new('NodeSocketBool','Fill Caps')
                group.outputs.new('NodeSocketGeometry','Geometry')
            links.new(group_input.outputs[0], reroute_Geometry_Input.inputs[0])
            links.new(node_Join_Geometry.outputs[0], group_output.inputs[0])
            links.new(group_input.outputs[1], reroute_Cables_No_Input.inputs[0])
            links.new(group_input.outputs[2], reroute_Global_XY_Offset_Input.inputs[0])
            links.new(group_input.outputs[3], reroute_Global_Offset_Seed_Input.inputs[0])
            links.new(group_input.outputs[4], reroute_Middle_Offset_Input.inputs[0])
            links.new(group_input.outputs[5], reroute_Middle_Offset_Seed_Input.inputs[0])
            links.new(group_input.outputs[6], reroute_Profile_Radius_Input.inputs[0])
            links.new(group_input.outputs[7], reroute_Profile_Res_Input.inputs[0])
            links.new(group_input.outputs[8], reroute_Profile_Object_Input.inputs[0])
            links.new(group_input.outputs[9], reroute_Use_Bevel_Object_Input.inputs[0])
            links.new(group_input.outputs[10], reroute_Fill_Caps_Input.inputs[0])
        return group
    def execute(self, context):
        self.obs = get_selected_curve_data(self, context.selected_objects)
        if not self.obs:
            self.report({'ERROR'}, "No valid curve objects were found among the selected objects, Aborting")
            return {'CANCELLED'}
        for obj in self.obs:
            curve, bevel_depth, bevel_resolution, resolution_u, bevel_mode, bevel_object, use_fill_caps = obj.values()
            if obj["bevel_mode"] == 'OBJECT':
                curve.data.bevel_object = None
            curve.data.bevel_depth = 0
            geo_mod = curve.modifiers.new(name='Cablerator GN',type='NODES')
            geo_group = self.get_cbl_node_group()
            geo_mod.node_group = geo_group
            input_name = "Socket" if GV.after4 else "Input"
            geo_mod[f"{input_name}_1"] = 3
            v = bevel_depth if bevel_depth > 0 else 0.35
            geo_mod[f"{input_name}_2"] = [v,v,0]
            geo_mod[f"{input_name}_3"] = 7
            geo_mod[f"{input_name}_4"] = [v,v,v]
            geo_mod[f"{input_name}_5"] = 13
            if bevel_mode == 'OBJECT':
                geo_mod[f"{input_name}_9"] = True
                geo_mod[f"{input_name}_8"] = bevel_object
            elif bevel_mode == 'ROUND':
                geo_mod[f"{input_name}_9"] = False
                geo_mod[f"{input_name}_7"] = math.ceil(linear(bevel_resolution, 0, 6, 4, 16))
                geo_mod[f"{input_name}_6"] = bevel_depth
            geo_mod[f"{input_name}_10"] = use_fill_caps
            curve.update_tag()
        return {'FINISHED'}
def register():
    bpy.utils.register_class(CBL_OT_ConvertCurveToGN)
    bpy.utils.register_class(CBL_OT_ConvertToMultiCableGN)
def unregister():
    bpy.utils.unregister_class(CBL_OT_ConvertCurveToGN)
    bpy.utils.unregister_class(CBL_OT_ConvertToMultiCableGN)